"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var createServer_exports = {};
__export(createServer_exports, {
  closeServer: () => closeServer,
  createServer: () => createServer,
  getServer: () => getServer,
  injectDataLoaderPlugin: () => injectDataLoaderPlugin,
  setServer: () => setServer
});
module.exports = __toCommonJS(createServer_exports);
var import_server = require("@modern-js/server");
let server = null;
const getServer = () => server;
const setServer = (newServer) => {
  server = newServer;
};
const closeServer = async () => {
  if (server) {
    await server.close();
    server = null;
  }
};
const createServer = async (options) => {
  if (server) {
    await server.close();
  }
  server = new import_server.Server(options);
  const app = await server.init();
  return app;
};
const injectDataLoaderPlugin = (internalPlugins) => {
  const DataLoaderPlugin = require.resolve("@modern-js/plugin-data-loader/server");
  return {
    ...internalPlugins,
    "@modern-js/plugin-data-loader": {
      path: DataLoaderPlugin,
      forced: true
    }
  };
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  closeServer,
  createServer,
  getServer,
  injectDataLoaderPlugin,
  setServer
});
