import { Server } from "@modern-js/server";
let server = null;
const getServer = () => server;
const setServer = (newServer) => {
  server = newServer;
};
const closeServer = async () => {
  if (server) {
    await server.close();
    server = null;
  }
};
const createServer = async (options) => {
  if (server) {
    await server.close();
  }
  server = new Server(options);
  const app = await server.init();
  return app;
};
const injectDataLoaderPlugin = (internalPlugins) => {
  const DataLoaderPlugin = require.resolve("@modern-js/plugin-data-loader/server");
  return {
    ...internalPlugins,
    "@modern-js/plugin-data-loader": {
      path: DataLoaderPlugin,
      forced: true
    }
  };
};
export {
  closeServer,
  createServer,
  getServer,
  injectDataLoaderPlugin,
  setServer
};
