import { _ as _async_to_generator } from "@swc/helpers/_/_async_to_generator";
import { _ as _object_spread } from "@swc/helpers/_/_object_spread";
import { _ as _object_spread_props } from "@swc/helpers/_/_object_spread_props";
import { _ as _ts_generator } from "@swc/helpers/_/_ts_generator";
import { ResolvedConfigContext } from "@modern-js/core";
import { DEFAULT_DEV_HOST } from "@modern-js/utils";
import { printInstructions } from "../utils/printInstructions";
import { setServer, createServer, injectDataLoaderPlugin } from "../utils/createServer";
import { generateRoutes } from "../utils/routes";
import { buildServerConfig } from "../utils/config";
import { getServerInternalPlugins } from "../utils/getServerInternalPlugins";
var dev = function() {
  var _ref = _async_to_generator(function(api, options) {
    var devServerOptions, _normalizedConfig_tools, normalizedConfig, appContext, hookRunners, appDirectory, distDirectory, port, apiOnly, serverConfigFile, metaName, serverInternalPlugins, serverOptions, _normalizedConfig_dev, app, host, server;
    var _arguments = arguments;
    return _ts_generator(this, function(_state) {
      switch (_state.label) {
        case 0:
          devServerOptions = _arguments.length > 2 && _arguments[2] !== void 0 ? _arguments[2] : {};
          if (options.analyze) {
            process.env.BUNDLE_ANALYZE = "true";
          }
          normalizedConfig = api.useResolvedConfigContext();
          appContext = api.useAppContext();
          hookRunners = api.useHookRunners();
          normalizedConfig = _object_spread_props(_object_spread({}, normalizedConfig), {
            cliOptions: options
          });
          ResolvedConfigContext.set(normalizedConfig);
          appDirectory = appContext.appDirectory, distDirectory = appContext.distDirectory, port = appContext.port, apiOnly = appContext.apiOnly, serverConfigFile = appContext.serverConfigFile, metaName = appContext.metaName;
          return [
            4,
            buildServerConfig({
              appDirectory,
              distDirectory,
              configFile: serverConfigFile,
              watch: true
            })
          ];
        case 1:
          _state.sent();
          return [
            4,
            hookRunners.beforeDev()
          ];
        case 2:
          _state.sent();
          if (!appContext.builder && !apiOnly) {
            throw new Error("Expect the Builder to have been initialized, But the appContext.builder received `undefined`");
          }
          return [
            4,
            generateRoutes(appContext)
          ];
        case 3:
          _state.sent();
          return [
            4,
            getServerInternalPlugins(api)
          ];
        case 4:
          serverInternalPlugins = _state.sent();
          serverOptions = _object_spread({
            dev: _object_spread({
              port,
              https: normalizedConfig.dev.https,
              host: normalizedConfig.dev.host
            }, (_normalizedConfig_tools = normalizedConfig.tools) === null || _normalizedConfig_tools === void 0 ? void 0 : _normalizedConfig_tools.devServer),
            appContext: {
              metaName,
              appDirectory: appContext.appDirectory,
              sharedDirectory: appContext.sharedDirectory,
              apiDirectory: appContext.apiDirectory,
              lambdaDirectory: appContext.lambdaDirectory
            },
            pwd: appDirectory,
            config: normalizedConfig,
            serverConfigFile,
            internalPlugins: injectDataLoaderPlugin(serverInternalPlugins)
          }, devServerOptions);
          if (!apiOnly)
            return [
              3,
              6
            ];
          return [
            4,
            createServer(_object_spread_props(_object_spread({}, serverOptions), {
              compiler: null
            }))
          ];
        case 5:
          app = _state.sent();
          host = ((_normalizedConfig_dev = normalizedConfig.dev) === null || _normalizedConfig_dev === void 0 ? void 0 : _normalizedConfig_dev.host) || DEFAULT_DEV_HOST;
          app.listen({
            port,
            host
          }, function() {
            var _ref2 = _async_to_generator(function(err) {
              return _ts_generator(this, function(_state2) {
                if (err) {
                  throw err;
                }
                printInstructions(hookRunners, appContext, normalizedConfig);
                return [
                  2
                ];
              });
            });
            return function(err) {
              return _ref2.apply(this, arguments);
            };
          }());
          return [
            3,
            8
          ];
        case 6:
          return [
            4,
            appContext.builder.startDevServer({
              serverOptions
            })
          ];
        case 7:
          server = _state.sent().server;
          setServer(server);
          _state.label = 8;
        case 8:
          return [
            2
          ];
      }
    });
  });
  return function dev2(api, options) {
    return _ref.apply(this, arguments);
  };
}();
export {
  dev
};
