import { _ as _async_to_generator } from "@swc/helpers/_/_async_to_generator";
import { _ as _object_spread } from "@swc/helpers/_/_object_spread";
import { _ as _object_spread_props } from "@swc/helpers/_/_object_spread_props";
import { _ as _ts_generator } from "@swc/helpers/_/_ts_generator";
import { logger, isApiOnly, getTargetDir } from "@modern-js/utils";
import server from "@modern-js/prod-server";
import { printInstructions } from "../utils/printInstructions";
import { injectDataLoaderPlugin } from "../utils/createServer";
import { getServerInternalPlugins } from "../utils/getServerInternalPlugins";
var start = function() {
  var _ref = _async_to_generator(function(api) {
    var _userConfig_source, _userConfig_output_distPath, appContext, userConfig, hookRunners, appDirectory, port, serverConfigFile, metaName, apiOnly, serverInternalPlugins, app;
    return _ts_generator(this, function(_state) {
      switch (_state.label) {
        case 0:
          appContext = api.useAppContext();
          userConfig = api.useResolvedConfigContext();
          hookRunners = api.useHookRunners();
          appDirectory = appContext.appDirectory, port = appContext.port, serverConfigFile = appContext.serverConfigFile, metaName = appContext.metaName;
          logger.info("Starting production server...");
          return [
            4,
            isApiOnly(appContext.appDirectory, userConfig === null || userConfig === void 0 ? void 0 : (_userConfig_source = userConfig.source) === null || _userConfig_source === void 0 ? void 0 : _userConfig_source.entriesDir, appContext.apiDirectory)
          ];
        case 1:
          apiOnly = _state.sent();
          return [
            4,
            getServerInternalPlugins(api)
          ];
        case 2:
          serverInternalPlugins = _state.sent();
          return [
            4,
            server({
              pwd: appDirectory,
              config: _object_spread_props(_object_spread({}, userConfig), {
                dev: userConfig.dev,
                output: _object_spread({
                  path: (_userConfig_output_distPath = userConfig.output.distPath) === null || _userConfig_output_distPath === void 0 ? void 0 : _userConfig_output_distPath.root
                }, userConfig.output || {})
              }),
              appContext: {
                metaName,
                sharedDirectory: getTargetDir(appContext.sharedDirectory, appContext.appDirectory, appContext.distDirectory),
                apiDirectory: getTargetDir(appContext.apiDirectory, appContext.appDirectory, appContext.distDirectory),
                lambdaDirectory: getTargetDir(appContext.lambdaDirectory, appContext.appDirectory, appContext.distDirectory)
              },
              serverConfigFile,
              internalPlugins: injectDataLoaderPlugin(serverInternalPlugins),
              apiOnly
            })
          ];
        case 3:
          app = _state.sent();
          app.listen(port, function() {
            var _ref2 = _async_to_generator(function(err) {
              return _ts_generator(this, function(_state2) {
                switch (_state2.label) {
                  case 0:
                    if (err) {
                      throw err;
                    }
                    return [
                      4,
                      printInstructions(hookRunners, appContext, userConfig)
                    ];
                  case 1:
                    _state2.sent();
                    return [
                      2
                    ];
                }
              });
            });
            return function(err) {
              return _ref2.apply(this, arguments);
            };
          }());
          return [
            2
          ];
      }
    });
  });
  return function start2(api) {
    return _ref.apply(this, arguments);
  };
}();
export {
  start
};
